VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 1  'NoTransaction
END
Attribute VB_Name = "clsEmail"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "This DLL and class are used to send SMTP Email to a Recipient(s).  This bypasses Exchange and makes emailing Easier.  It uses CDO for Win2000 so is can only run under Win2000."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'************************************************************************************
'*  Proc Name:      clsEmail                                                        *
'*  Date:           Wednesday, September 13, 2000                                   *
'*  Author:         Kevin Henderson                                                 *
'*  Compiler:       Microsoft Visual Basic 6.00                                     *
'*  Synop:          This class will send STMP email. Note: this class, and          *
'*                  The DLL was created by me before I joined ASGL, as such, I own  *
'*                  The copywrite created of all original code, not any code        *
'*                  Add into this DLL dated after Wednesday, September 13, 2000     *
'*                  The date I brought this DLL in.                                 *
'************************************************************************************


Public Enum EmailType
    TextOnly = 0
    HTML = 1
End Enum


Private objmessage  As CDO.Message
Private iConf       As CDO.Configuration
Private Flds        As ADODB.Fields

Public Sub Send(ByVal Message As String, ByVal Subject As String, ByVal RecipientList As clsRecipients, ByRef SentOK As Long, ByRef SentFail As Long, Optional ByVal IPAddress As String = "", Optional ByVal From As String, Optional ByVal MessageToSend As EmailType = HTML, Optional ByVal MessagePassedType As EmailType = TextOnly, Optional ByVal Attachment As String = "")

'************************************************************************************
'*  Function Name:  SendComplexMail()                                               *
'*  Date:           Friday, Feb 16, 2001                                            *
'*  Author:         Kevin Henderson                                                 *
'*  Compiler:       Microsoft Visual Basic 6.00                                     *
'*  Args:                                                                           *
'*                  String:  Message --IN-- The Message to Email                    *
'*                  String:  Subject --IN-- The Email Subject.                      *
'*                  clsRecipients: RecipientList --Names of Persons to recieve Email*
'*                                  And type of email, Regular TO, CC or BCC        *
'*                  Long:   SentOK -- Out -- Returns the number of Emails that are  *
'*                                           Sent with no errors                    *
'*                  Long:   SentFail -- Out -- Returns the number of Emails that are*
'*                                           Sent errors                            *
'*                  String:  IPAddress -- IN -- Optional, the IP Address of Your Mail*
'*                                              Server.  The IP address in the      *
'*                                              Class_Initialize() should be fine   *
'*                                              If you multiple mail servers, you   *
'*                                              Explicitly change this IP to share  *
'*                                              The load.                           *
'*                  String:  From --IN-- Who you want the Email to be from, this    *
'*                           Will show up in the users Email Box. If left empty, The*
'*                           Default of "complus@angus-group.com" will be used.     *
'*                  EmailType: MessageToSend --IN-- How do you want the message sent*
'*                                     As Text Based or HTML Based Email, default is*
'*                                     HTML.                                        *
'*                  EmailType: MessagePassedType --IN-- How are you passing the     *
'*                                     Message, as Text only and you want me to add *
'*                                     HTML formating, or are you sending your own  *
'*                                     full HTML in the message. The Default is     *
'*                                     TextOnly. This is ignored if Email Type is   *
'*                                     set to TextOnly.                             *
'*                  String:    Attachment -- IN -- The Path & File Name of any      *
'*                             Attachment.                                          *
'*  Returns:        Boolean:  True if Email sent OK, False if not                   *
'*                                                                                  *
'*  Synop:          This function will sent SMTP based email directly to the        *
'*                  Recipient(s), bypassing Exchange.                               *
'*                                                                                  *
'************************************************************************************

Dim ParsMessage()       As String
Dim MessageTxt          As String
Dim SendTo              As String

Dim Recip               As clsRecipient

Dim Count               As Long

Dim SendCounter         As Long

On Error GoTo SendError

    If Trim(IPAddress) <> "" Then
        iConf.Fields(cdoSMTPServer) = IPAddress
    End If
    
    If Trim(From) = "" Then
        From = ""                               ' Add your default address here
    End If
    
    If MessageToSend = HTML Then
                                
        If MessagePassedType = HTML Then
            MessageTxt = Message
        Else
            'convert to HTML
            ParsMessage = Split(Message, vbCrLf) ' look for line breaks
        
               
            If UBound(ParsMessage) > 0 Then
                Message = Empty
                
                For Count = 0 To UBound(ParsMessage)
                    DoEvents
                    Message = Message & ParsMessage(Count) & "<br>"
                Next
            
            End If
            
            MessageTxt = Message
        End If
    Else
        MessageTxt = Message
    End If
    
    
    For Each Recip In RecipientList
        With objmessage
            Set .Configuration = iConf
            DoEvents
            
            .From = From
            
            Select Case Recip.RecipientType
                Case Is = smtpBCCRecipient
                    .BCC = Recip.Address
                Case Is = smtpCCRecipient
                    .CC = Recip.Address
                Case Is = smtpToRecipient
                    .To = Recip.Address
            End Select
            
            .Subject = Subject
            
            If MessageToSend = HTML Then
                .HTMLBody = MessageTxt
            Else
                .TextBody = MessageTxt
            End If
            
            If Trim(Attachment) <> "" Then
                .AddAttachment Attachment
            End If
            
            If SendMail Then
                SentOK = SentOK + 1
            Else
                SentFail = SentFail + 1
            End If
            
            DoEvents
            
        
        End With
    Next
Exit Sub

SendError:
    
    Resume Next
    
End Sub
Private Function SendMail() As Boolean

'********************************************************************************
'*  Function Name:  SendMail                                                    *
'*  Date:           Sunday, May 27, 2001                                        *
'*  Author:         Kevin Henderson                                             *
'*  Compiler:       Microsoft Visual Basic 6.00                                 *
'*  Synop:          This function will send the mail                            *
'*                                                                              *
'********************************************************************************

On Error GoTo SendError

    objmessage.Send
    
    SendMail = True
Exit Function

SendError:
    SendMail = False

End Function

Private Sub Class_Initialize()

Set objmessage = CreateObject("CDO.Message")
    Set iConf = New CDO.Configuration
    
    Set Flds = iConf.Fields
    
    Flds(cdoSendUsingMethod) = cdoSendUsingPort          ' 2
    '************************************************************
    '* Set this IP address to your Email server IP address, this*
    '*Can the mail server on your work network, or the IP       *
    '*Address of your ISP, contact your ISP for this address,   *
    '*They are more then willing to give it to you.             *
    '************************************************************
    Flds(cdoSMTPServer) = ""    ' for example "192.168.1.2" note this example is a bogus IP
    Flds(cdoSMTPServerPort) = 25
    Flds(cdoSMTPUseSSL) = False
Flds.Update

End Sub

Private Sub Class_Terminate()
    Set objmessage = Nothing
    Set iConf = Nothing
End Sub

